--функции работы с файлами с записью ошибок в лог
local mod = {}

local file = tmsFile() --файлы
local log = tmsLog() --log file
local sys = tmsSys()

-- запись строки в файл, новый файл создается, старый удаляется 
function mod.fileWrite( filename, s )
  local res = file.fileWrite( filename, s )
  if not res then
    log.ERR( 'do not write file ', filename, sys.errStr() )
  end
  return res
end

-- добавление строки в файл, если файла нет, то новый файл создается
function mod.fileAppend( filename, s )
  local res = file.fileAppend( filename, s )
  if not res then
    log.ERR( 'do not append file ', filename, sys.errStr() )
  end
  return res
end

-- удаление файла
function mod.fileDel( filename )
  local res = file.fileDel( filename )
  if res ~= 0 then
    log.ERR( 'do not del file ', filename, sys.errStr() )
  end
  return res
end

-- переименование файла
function mod.fileRename( old_filename, new_filename )
  local res = file.fileRename( old_filename, new_filename ) ~= 0
  if res ~= 0 then
    log.ERR( 'do not rename file ', old_filename, ' to ', new_filename, sys.errStr() )
  end
  return res
end

-- размер файла
function mod.fileSize( filename )
  local sz = file.fileSize( filename )
  if sz < 0 then
    log.ERR( 'do not get size of file ', filename, sys.errStr() )
  end
  return sz
end

-- рекурсивное создание папки
function mod.dirForce( dirname )
  local res = file.dirForce( dirname )
  if not res then
    log.ERR( 'do not create dir ', dirname, sys.errStr() )
  end
  return res
end

function mod.fileStat( filename )
  local fs = file.fileStat( filename )
  if fs == nil then
    log.ERR( filename, 'do not get stat of file', sys.errStr() )
  end
  return fs
end

return mod
