--функции для JSON
--[[
--пример
package.path = svr.tmsDirScript("mods").."?.lua;"..package.path
local jsh = require( 'tmsJsonHelper' )

local json = tmsNewJsonReader() -- json parser
--таблицу из json
local sj = '{"par":"val"}'
local t1 = jsh.fromJson( json, sj )
--или
json:jsonOpen( sj )
local t2 = jsh.fromJson( json )
json:jsonClose()

--таблицу в json
local t = { par1='val', par2=222 }
local s = jsh.toJson( t )
]]--

local mod = {}

function mod.fromJson( json, sj )
  if sj ~= nil then
    json:jsonOpen( sj )
  end
  local nxtps = json.nextTypes()
  function totab( t )
    while json:hasNext() do
      local par
      local nx = json:whatNext()
      if nx == nxtps.nxValue then
        par = json:nextParam()
        if json:hasNext() then
          nx = json:whatNext()
          if nx == nxtps.nxValue then
            local val = json:nextValue2()
            t[par] = val
--            log.TRACE( par,':',val )
          end
        end
      end
      if nx == nxtps.nxValue then --next value
      elseif nx == nxtps.nxObject then-- object
        json:beginObject()
        if par ~= nil then
--          log.TRACE( par,': OBJECT' )
          local obj = {}
          totab( obj )
          t[par] = obj-- object
        else
          totab( t ) -- root object
        end
        json:endObject()
      elseif nx == nxtps.nxArray then-- array
        local arr = {}
        if par ~= nil then
--          log.TRACE( par,': ARRAY' )
          t[par] = arr-- array
        else
          t = arr --root array
        end
        local i = 1
        json:beginArray()
        while json:hasNext() do
          nx = json:whatNext()
          if nx == nxtps.nxValue then
            local val = json:nextArrayValue2()
            arr[i] = val
--            log.TRACE( i,':',val )
          else
            local obj = {}
            totab( obj )
            arr[i] = obj
          end
          i = i + 1
        end--while
        json:endArray()
      end--array
    end--while
  end--totab
  local t = {}
  totab( t )
  if sj ~= nil then
    json:jsonClose()
  end
  return t
end

function mod.toJson( o )
  if o == nil then
    return 'null'
  end
  if type(o) == 'table' then
    local s = ''
    local a = ''
    local i = 1
    for k,v in pairs(o) do
      if s:len() > 0 then
        s = s..','
      end
      local ss = mod.toJson(v)
      s = s..'"'..k..'":'..ss
      if i ~= 0 then
        if i == k then
          i = i + 1
          if a:len() > 0 then
            a = a..','
          end
          a = a..ss
        else
          i = 0
        end
      end
    end
    if i == 0 then
      return '{'..s..'}'
    else
      return '['..a..']'
    end
  end
  if type(o) == 'string' then
    return '"'..o..'"'
  end
  return tostring(o)
end--toJson

return mod
